// Python & Java convenience

%{
#include <sstream>
%}

%define STRINGHELPER(classname)
%extend classname {
    char * toString() {
		static char temp[512];
        std::ostringstream os;
		os << (*self);
		strcpy(temp, os.str().c_str());
        return &temp[0];
    }
    
    std::string __str__() {
        static char temp[512];
        std::ostringstream os;
		os << (*self);
		strcpy(temp, os.str().c_str());
        return &temp[0];
    }
};
%enddef // STRINGHELPER

%include "rave.i"

%pragma(java) jniclasscode = %{
	static {
		String libname = System.mapLibraryName( "JavaRave" );

		try {
			try {   
                                System.load ( "/usr/local/lib/jni/" + libname );
				System.out.println( libname + " successfully loaded!" );
			} catch(UnsatisfiedLinkError e) {
				libname = "libJavaRave.so";
				System.load ( "/usr/local/lib/jni/" + libname );
				System.out.println( libname + " successfully loaded!" );
			}
		} catch(SecurityException e) {
			System.out.println( libname + " not loaded!" );
			e.printStackTrace();
		} catch(UnsatisfiedLinkError e) {
			System.out.println( libname + " not loaded!" );
			e.printStackTrace();
		}
	}
%}
