#include "DataFormats/Math/interface/Point3D.h"

math::XYZPoint::XYZPoint() : x_(0.), y_(0.), z_(0.) {}

math::XYZPoint::XYZPoint ( double x, double y, double z ) :
  x_(x), y_(y), z_(z)
{}

math::XYZPoint::XYZPoint ( const GlobalPoint & g ) :
  x_(g.x()), y_(g.y()), z_(g.z())
{}

void math::XYZPoint::SetX ( double x )
{
  x_=x;
}

void math::XYZPoint::SetY ( double y )
{
  y_=y;
}
void math::XYZPoint::SetZ ( double z )
{
  z_=z;
}

double math::XYZPoint::X() const 
{
  return x_;
}

double math::XYZPoint::Y() const 
{
  return y_;
}

double math::XYZPoint::Z() const 
{
  return z_;
}

double math::XYZPoint::x() const 
{
  return x_;
}

double math::XYZPoint::y() const 
{
  return y_;
}

double math::XYZPoint::z() const 
{
  return z_;
}

double math::XYZPoint::perp2() const
{
  return x_*x_ + y_*y_;
}

std::ostream& operator<< ( std::ostream& os, const math::XYZPoint & p )
{
  os << "(" << p.x() << ", " << p.y() << ", " << p.z() << ")";
  return os;
}

edm::LogBase& operator<< ( edm::LogBase& os, const math::XYZPoint & p )
{
  os << "(" << p.x() << ", " << p.y() << ", " << p.z() << ")";
  return os;
}
