#ifndef _CalibrationRun_H_
#define _CalibrationRun_H_

#include <string>

namespace rave 
{
  class CalibrationRun
  {
    /**
     *  All meta info for one calibration run in one object
     */
    public:
      CalibrationRun ( const std::string & date,
                       int n_events,
                       const std::string & vtx_rector,
                       const std::string & external_version,
                       const std::string & sample,
                       const std::string & rave_version );

      const std::string & date() const;
      const int nevents() const;
      const std::string & vertexReconstructor() const;

      // version of the embedding software
      const std::string & externalVersion() const;

      // rave version during the run
      const std::string & raveVersion() const;
      const std::string & sample() const;

    private:
      std::string date_;
      int nevents_;
      std::string vtxrector_;
      std::string externalVer_;
      std::string sample_;
      std::string raveVer_;
  };
}

#endif
