#ifndef _RaveCovariance3D_H_
#define _RaveCovariance3D_H_

//#include "boost/operators.hpp"

namespace rave
{

/**
 * @class RaveCovariance3D defines the input to the rave library.
 */

class Covariance3D
  //: boost::equality_comparable<Covariance3D>
{
  public:

    /**
     *  Create a RaveCovariance3D from a 6-dimensional euclidean trajectory state
     *  plus covariance matrix, plus charge
     */
    Covariance3D( double dxx, double dxy, double dxz,
                      double dyy, double dyz, double dzz );
    Covariance3D();

    double dxx() const;
    double dxy() const;
    double dxz() const;
    double dyy() const;
    double dyz() const;
    double dzz() const;

    bool equal(const Covariance3D & other) const;

  private:
    double thedxx;
    double thedxy;
    double thedxz;
    double thedyy;
    double thedyz;
    double thedzz;
};

} // namespace rave

bool operator==(const rave::Covariance3D & lhs, const rave::Covariance3D & rhs);

#endif
