//
// C++ Interface: Covariance4D
//
// Description:
//
//
// Author: Fabian Moser <fabiamos@gmail.com>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef RAVECOVARIANCE4D_H
#define RAVECOVARIANCE4D_H

#include <rave/Covariance3D.h>

namespace rave
{

/**
        @author Fabian Moser <fabiamos@gmail.com>
*/
class Covariance4D :
    public rave::Covariance3D
{
  public:
    Covariance4D ( double dxx, double dxy, double dxz, double dxm,
                   double dyy, double dyz, double dym,
                   double dzz, double dzm, double dmm );
    Covariance4D();

    double dxm() const;
    double dym() const;
    double dzm() const;
    double dmm() const;

    bool equal ( const rave::Covariance4D & other ) const;

  private:
    double thedxm;
    double thedym;
    double thedzm;
    double thedmm;

};

} // namespace rave

bool operator==(const rave::Covariance4D & lhs, const rave::Covariance4D & rhs);

#endif
