#ifndef _RavePoint3D_H_
#define _RavePoint3D_H_

#include <cmath>

#include "boost/operators.hpp"

namespace rave
{

/**
 * @class Point3D a point in 3d space
 */

class Point3D :
    boost::equality_comparable<Point3D>
{
  public:

    Point3D( double x, double y, double z );
    Point3D();

    double x() const;
    double y() const;
    double z() const;

    double mag() const;
    double mag2() const;

    double perp() const;
    double perp2() const;

    bool equal(const Point3D & other) const;

  private:
    double thex;
    double they;
    double thez;
};

} // namespace rave

bool operator==(const rave::Point3D & lhs, const rave::Point3D & rhs);

#endif

