//
// C++ Interface: Vector4D
//
// Description:
//
//
// Author: Fabian Moser <fabiamos@gmail.com>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef RAVEVECTOR4D_H
#define RAVEVECTOR4D_H

#include <rave/Vector3D.h>

namespace rave
{

/**
        @author Fabian Moser <fabiamos@gmail.com>
*/
class Vector4D :
      public rave::Vector3D,
      boost::equality_comparable<Vector4D>
{
  public:
    Vector4D( double x, double y, double z, double m );
    Vector4D( rave::Vector3D v, double m );
    Vector4D();

    double m() const;

    bool equal( const rave::Vector4D & ) const;

  private:
    double them;

};

} // namespace rave

bool operator==(const rave::Vector4D & lhs, const rave::Vector4D & rhs);

#endif
