#include "RaveBase/RaveInterface/rave/Histogram.h"
#include "FWCore/MessageLogger/interface/MessageLogger.h"
#include <iostream>

using namespace rave;
using namespace std;

Histogram::Histogram() : theEntries(0) {}

Histogram::Histogram ( const map < float, float > & histo, int e ) :
  theHisto ( histo ), theEntries(e) 
{
  edm::LogError("RaveHistogram" ) << "constructor with " << theEntries;
}

void Histogram::add ( float ulimit, float value, int n )
{
  theHisto[ulimit]=value;
  theEntries+=n;
}

void Histogram::dump() const
{
  for ( map < float, float >::const_iterator i=theHisto.begin(); i!=theHisto.end() ; ++i )
    cout << i->first << "	: " << i->second << endl;
}

const map < float, float > & Histogram::getMap() const
{
  return theHisto;
}

int Histogram::entries() const
{
  return theEntries;
}

void Histogram::setEntries( int e ) 
{
  theEntries=e;
  // if (  e!=0 ) { edm::LogError("RaveHistogram" ) << "setting to " << theEntries; };
}

void Histogram::addEntries( int e ) 
{
  theEntries+=e;
  // edm::LogError("RaveHistogram" ) << "adding to " << theEntries;
}

vector < float > Histogram::getULimits() const
{
  vector < float > ret;
  for ( map < float, float >::const_iterator i=theHisto.begin(); i!=theHisto.end() ; ++i )
  {
    ret.push_back ( i->first );
  }
  return ret;
}
