#include "RecoVertex/ConfigurableVertexReco/interface/ConfigurableLinPtFinder.h"
#include "RecoVertex/ConfigurableVertexReco/interface/FitterFromLinPtFinder.h"
#include "RecoVertex/LinearizationPointFinders/interface/DefaultLinearizationPointFinder.h"

using namespace std;

namespace {
  edm::ParameterSet mydefaults()
  {
    edm::ParameterSet ret;
//    ret.addParameter<string>("name","default");
    return ret;
  }
}
    
ConfigurableLinPtFinder::ConfigurableLinPtFinder() :
    AbstractConfFitter ( FitterFromLinPtFinder ( DefaultLinearizationPointFinder()  ) )
{}

void ConfigurableLinPtFinder::configure(
    const edm::ParameterSet & n )
{
  edm::ParameterSet m = mydefaults();
  m.augment ( n );
  if ( theFitter ) delete theFitter;
  theFitter = new FitterFromLinPtFinder ( DefaultLinearizationPointFinder() );
}

ConfigurableLinPtFinder::~ConfigurableLinPtFinder()
{
  if ( theFitter ) delete theFitter;
}

ConfigurableLinPtFinder::ConfigurableLinPtFinder 
    ( const ConfigurableLinPtFinder & o ) :
  AbstractConfFitter ( o )
{}

ConfigurableLinPtFinder * ConfigurableLinPtFinder::clone() const
{
  return new ConfigurableLinPtFinder ( *this );
}

edm::ParameterSet ConfigurableLinPtFinder::defaults() const
{
  return mydefaults();
}

#include "RecoVertex/ConfigurableVertexReco/interface/ConfFitterBuilder.h"

namespace {
  ConfFitterBuilder < ConfigurableLinPtFinder > t ( "linpt", "LinearizationPointFinder" );
}
