#include "RecoVertex/ConfigurableVertexReco/interface/ConfigurableZvresReconstructor.h"
#include "RecoVertex/ZvresReco/interface/ZvresVertexReconstructor.h"

using namespace std;

ConfigurableZvresReconstructor::ConfigurableZvresReconstructor() :
    theRector( new ZvresVertexReconstructor() )
{}

void ConfigurableZvresReconstructor::configure(
    const edm::ParameterSet & n )
{
  delete theRector;
  theRector = new ZvresVertexReconstructor();
}

ConfigurableZvresReconstructor::~ConfigurableZvresReconstructor()
{
  delete theRector;
}

ConfigurableZvresReconstructor::ConfigurableZvresReconstructor 
    ( const ConfigurableZvresReconstructor & o ) :
  theRector ( o.theRector->clone() )
{}


ConfigurableZvresReconstructor * ConfigurableZvresReconstructor::clone() const
{
  return new ConfigurableZvresReconstructor ( *this );
}

vector < TransientVertex > ConfigurableZvresReconstructor::vertices ( 
    const std::vector < reco::TransientTrack > & t ) const
{
  return theRector->vertices ( t );
}

vector < TransientVertex > ConfigurableZvresReconstructor::vertices ( 
    const std::vector < reco::TransientTrack > & t,
    const reco::BeamSpot & s ) const
{
  return theRector->vertices ( t, s );
}

edm::ParameterSet ConfigurableZvresReconstructor::defaults() const
{
  return edm::ParameterSet();
}

#include "RecoVertex/ConfigurableVertexReco/interface/ConfRecoBuilder.h"

namespace {
  ConfRecoBuilder < ConfigurableZvresReconstructor > t
    ( "zvres", "Topological vertexing" );
}
